Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports O2S.Barcode4NET

Namespace BarcodeGridColumn
	''' <summary>
	''' Main application form.
	''' </summary>
	Public Class MainForm
		Inherits System.Windows.Forms.Form
		Private dataGrid As System.Windows.Forms.DataGrid
		Private dataGridTableStyle As System.Windows.Forms.DataGridTableStyle
		Private companyNameColumn As System.Windows.Forms.DataGridTextBoxColumn
		Private contactNameColumn As System.Windows.Forms.DataGridTextBoxColumn
		Private contactTitleColumn As System.Windows.Forms.DataGridTextBoxColumn
		Private addressColumn As System.Windows.Forms.DataGridTextBoxColumn
		Private cityColumn As System.Windows.Forms.DataGridTextBoxColumn
		Private regionColumn As System.Windows.Forms.DataGridTextBoxColumn
		Private postalCodeColumn As System.Windows.Forms.DataGridTextBoxColumn
		Private countryColumn As System.Windows.Forms.DataGridTextBoxColumn
		Private phoneColumn As System.Windows.Forms.DataGridTextBoxColumn
		Private faxColumn As System.Windows.Forms.DataGridTextBoxColumn
		Private WithEvents btnPrintPreview As System.Windows.Forms.Button
		Private printPreviewDialog As System.Windows.Forms.PrintPreviewDialog
		Private WithEvents printDocument As System.Drawing.Printing.PrintDocument
		Private customerIDColumn As System.Windows.Forms.DataGridTextBoxColumn
		''' <summary>
		''' Required designer variable.
		''' </summary>
		Private components As System.ComponentModel.Container = Nothing

		''' <summary>
		''' The index of the first row on current page.
		''' </summary>
		Private rowIndex As Integer

		''' <summary>
		''' List of customers to be printed.
		''' </summary>
		Private customers As DataSet

		Public Sub New()
			'
			' Required for Windows Form Designer support
			'
			InitializeComponent()

			'
			' TODO: Add any constructor code after InitializeComponent call
			'
		End Sub

		''' <summary>
		''' Clean up any resources being used.
		''' </summary>
		Protected Overrides Overloads Sub Dispose(ByVal disposing As Boolean)
			If disposing Then
				If Not components Is Nothing Then
					components.Dispose()
				End If
			End If
			MyBase.Dispose(disposing)
		End Sub

		#Region "Windows Form Designer generated code"
		''' <summary>
		''' Required method for Designer support - do not modify
		''' the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
			Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(MainForm))
			Me.dataGrid = New System.Windows.Forms.DataGrid()
			Me.dataGridTableStyle = New System.Windows.Forms.DataGridTableStyle()
			Me.companyNameColumn = New System.Windows.Forms.DataGridTextBoxColumn()
			Me.contactNameColumn = New System.Windows.Forms.DataGridTextBoxColumn()
			Me.contactTitleColumn = New System.Windows.Forms.DataGridTextBoxColumn()
			Me.addressColumn = New System.Windows.Forms.DataGridTextBoxColumn()
			Me.cityColumn = New System.Windows.Forms.DataGridTextBoxColumn()
			Me.regionColumn = New System.Windows.Forms.DataGridTextBoxColumn()
			Me.postalCodeColumn = New System.Windows.Forms.DataGridTextBoxColumn()
			Me.countryColumn = New System.Windows.Forms.DataGridTextBoxColumn()
			Me.phoneColumn = New System.Windows.Forms.DataGridTextBoxColumn()
			Me.faxColumn = New System.Windows.Forms.DataGridTextBoxColumn()
			Me.btnPrintPreview = New System.Windows.Forms.Button()
			Me.printPreviewDialog = New System.Windows.Forms.PrintPreviewDialog()
			Me.printDocument = New System.Drawing.Printing.PrintDocument()
			Me.customerIDColumn = New System.Windows.Forms.DataGridTextBoxColumn()
			CType(Me.dataGrid, System.ComponentModel.ISupportInitialize).BeginInit()
			Me.SuspendLayout()
			' 
			' dataGrid
			' 
			Me.dataGrid.Anchor = (CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) Or System.Windows.Forms.AnchorStyles.Left) Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles))
			Me.dataGrid.CaptionText = "Customers"
			Me.dataGrid.DataMember = ""
			Me.dataGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText
			Me.dataGrid.Location = New System.Drawing.Point(0, 0)
			Me.dataGrid.Name = "dataGrid"
			Me.dataGrid.Size = New System.Drawing.Size(544, 284)
			Me.dataGrid.TabIndex = 0
			Me.dataGrid.TableStyles.AddRange(New System.Windows.Forms.DataGridTableStyle() { Me.dataGridTableStyle})
			' 
			' dataGridTableStyle
			' 
			Me.dataGridTableStyle.DataGrid = Me.dataGrid
			Me.dataGridTableStyle.GridColumnStyles.AddRange(New System.Windows.Forms.DataGridColumnStyle() { Me.customerIDColumn, Me.companyNameColumn, Me.contactNameColumn, Me.contactTitleColumn, Me.addressColumn, Me.cityColumn, Me.regionColumn, Me.postalCodeColumn, Me.countryColumn, Me.phoneColumn, Me.faxColumn})
			Me.dataGridTableStyle.HeaderForeColor = System.Drawing.SystemColors.ControlText
			Me.dataGridTableStyle.MappingName = "Customers"
			' 
			' companyNameColumn
			' 
			Me.companyNameColumn.Format = ""
			Me.companyNameColumn.FormatInfo = Nothing
			Me.companyNameColumn.HeaderText = "Company Name"
			Me.companyNameColumn.MappingName = "CompanyName"
			Me.companyNameColumn.Width = 200
			' 
			' contactNameColumn
			' 
			Me.contactNameColumn.Format = ""
			Me.contactNameColumn.FormatInfo = Nothing
			Me.contactNameColumn.HeaderText = "Contact Name"
			Me.contactNameColumn.MappingName = "ContactName"
			Me.contactNameColumn.Width = 120
			' 
			' contactTitleColumn
			' 
			Me.contactTitleColumn.Format = ""
			Me.contactTitleColumn.FormatInfo = Nothing
			Me.contactTitleColumn.HeaderText = "Contact Title"
			Me.contactTitleColumn.MappingName = "ContactTitle"
			Me.contactTitleColumn.Width = 120
			' 
			' addressColumn
			' 
			Me.addressColumn.Format = ""
			Me.addressColumn.FormatInfo = Nothing
			Me.addressColumn.HeaderText = "Address"
			Me.addressColumn.MappingName = "Address"
			Me.addressColumn.Width = 150
			' 
			' cityColumn
			' 
			Me.cityColumn.Format = ""
			Me.cityColumn.FormatInfo = Nothing
			Me.cityColumn.HeaderText = "City"
			Me.cityColumn.MappingName = "City"
			Me.cityColumn.Width = 75
			' 
			' regionColumn
			' 
			Me.regionColumn.Format = ""
			Me.regionColumn.FormatInfo = Nothing
			Me.regionColumn.HeaderText = "Region"
			Me.regionColumn.MappingName = "Region"
			Me.regionColumn.Width = 75
			' 
			' postalCodeColumn
			' 
			Me.postalCodeColumn.Format = ""
			Me.postalCodeColumn.FormatInfo = Nothing
			Me.postalCodeColumn.HeaderText = "Postal Code"
			Me.postalCodeColumn.MappingName = "PostalCode"
			Me.postalCodeColumn.Width = 75
			' 
			' countryColumn
			' 
			Me.countryColumn.Format = ""
			Me.countryColumn.FormatInfo = Nothing
			Me.countryColumn.HeaderText = "Country"
			Me.countryColumn.MappingName = "Country"
			Me.countryColumn.Width = 75
			' 
			' phoneColumn
			' 
			Me.phoneColumn.Format = ""
			Me.phoneColumn.FormatInfo = Nothing
			Me.phoneColumn.HeaderText = "Phone"
			Me.phoneColumn.MappingName = "Phone"
			Me.phoneColumn.Width = 75
			' 
			' faxColumn
			' 
			Me.faxColumn.Format = ""
			Me.faxColumn.FormatInfo = Nothing
			Me.faxColumn.HeaderText = "Fax"
			Me.faxColumn.MappingName = "Fax"
			Me.faxColumn.Width = 75
			' 
			' btnPrintPreview
			' 
			Me.btnPrintPreview.Location = New System.Drawing.Point(424, 288)
			Me.btnPrintPreview.Name = "btnPrintPreview"
			Me.btnPrintPreview.Size = New System.Drawing.Size(116, 23)
			Me.btnPrintPreview.TabIndex = 1
			Me.btnPrintPreview.Text = "Print preview"
'			Me.btnPrintPreview.Click += New System.EventHandler(Me.btnPrintPreview_Click);
			' 
			' printPreviewDialog
			' 
			Me.printPreviewDialog.AutoScrollMargin = New System.Drawing.Size(0, 0)
			Me.printPreviewDialog.AutoScrollMinSize = New System.Drawing.Size(0, 0)
			Me.printPreviewDialog.ClientSize = New System.Drawing.Size(400, 300)
			Me.printPreviewDialog.Document = Me.printDocument
			Me.printPreviewDialog.Enabled = True
			Me.printPreviewDialog.Icon = (CType(resources.GetObject("printPreviewDialog.Icon"), System.Drawing.Icon))
			Me.printPreviewDialog.Location = New System.Drawing.Point(198, 137)
			Me.printPreviewDialog.MinimumSize = New System.Drawing.Size(375, 250)
			Me.printPreviewDialog.Name = "printPreviewDialog"
			Me.printPreviewDialog.TransparencyKey = System.Drawing.Color.Empty
			Me.printPreviewDialog.Visible = False
			' 
			' printDocument
			' 
'			Me.printDocument.BeginPrint += New System.Drawing.Printing.PrintEventHandler(Me.printDocument_BeginPrint);
'			Me.printDocument.QueryPageSettings += New System.Drawing.Printing.QueryPageSettingsEventHandler(Me.printDocument_QueryPageSettings);
'			Me.printDocument.PrintPage += New System.Drawing.Printing.PrintPageEventHandler(Me.printDocument_PrintPage);
			' 
			' customerIDColumn
			' 
			Me.customerIDColumn.Format = ""
			Me.customerIDColumn.FormatInfo = Nothing
			Me.customerIDColumn.HeaderText = "Customer ID"
			Me.customerIDColumn.MappingName = "CustomerID"
			Me.customerIDColumn.Width = 70
			' 
			' MainForm
			' 
			Me.AutoScaleBaseSize = New System.Drawing.Size(5, 14)
			Me.ClientSize = New System.Drawing.Size(544, 313)
			Me.Controls.Add(Me.btnPrintPreview)
			Me.Controls.Add(Me.dataGrid)
			Me.Font = New System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, (CByte(0)))
			Me.Icon = (CType(resources.GetObject("$this.Icon"), System.Drawing.Icon))
			Me.Name = "MainForm"
			Me.Text = "Barcode4NET - Barcode Print demo"
'			Me.Load += New System.EventHandler(Me.MainForm_Load);
			CType(Me.dataGrid, System.ComponentModel.ISupportInitialize).EndInit()
			Me.ResumeLayout(False)

		End Sub
		#End Region

		''' <summary>
		''' The main entry point for the application.
		''' </summary>
		<STAThread> _
		Shared Sub Main()
			Application.Run(New MainForm())
		End Sub

		Private Sub MainForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
			' Load the customers dataset.
			customers = New DataSet()
			' The path is relative to the exe file.
            customers.ReadXml("..\..\Samples\Windows Forms\BarcodePrint\VBNET\Net 2.0\customers.net20.xml", XmlReadMode.ReadSchema)
			customers.Tables(0).TableName = "Customers"

			' Bind the data to the grid.
			dataGrid.DataSource = customers.Tables(0)
		End Sub

		Private Sub btnPrintPreview_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnPrintPreview.Click
			printPreviewDialog.ShowDialog()
		End Sub

		Private Sub printDocument_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles printDocument.PrintPage
			Dim leftMargin As Single = e.MarginBounds.Left
			Dim topMargin As Single = e.MarginBounds.Top
			Dim topPosition As Single = 0

			Dim blackBrush As SolidBrush = New SolidBrush(Color.Black)
			Dim fontTitle As Font = New Font("Tahoma", 8, FontStyle.Bold, GraphicsUnit.Point)
			Dim fontText As Font = New Font("Tahoma", 8, GraphicsUnit.Point)
			Dim fontHeight As Single = fontText.GetHeight(e.Graphics)
			Dim sectionHeight As Single = fontHeight * 6
			Dim leftTextOffset As Single = 160

			' Use a Code 39 barcode.
			Dim barcode As Code39Barcode = New Code39Barcode()
			barcode.DimensionUnit = XYDimensionUnit.Inch
			barcode.XDimension = 1/72f
			barcode.YDimension = 0.5f
			barcode.DataDisplayLocation = BarcodeTextLocation.BelowEmbedded

			Do
				' If a full customer section does not fit on the page, go to next page.
				If topPosition + sectionHeight > e.MarginBounds.Height Then
					Exit Do
				End If
				' If there are no more rows, exit.
				If rowIndex >= customers.Tables(0).Rows.Count Then
					Exit Do
				End If

				' Get the data from current row.
				Dim customerID As String = customers.Tables(0).Rows(rowIndex)("CustomerID").ToString()
				Dim companyName As String = customers.Tables(0).Rows(rowIndex)("CompanyName").ToString()
				Dim contactName As String = customers.Tables(0).Rows(rowIndex)("ContactName").ToString()
				Dim contactTitle As String = customers.Tables(0).Rows(rowIndex)("ContactTitle").ToString()
				Dim address As String = customers.Tables(0).Rows(rowIndex)("Address").ToString()
				Dim city As String = customers.Tables(0).Rows(rowIndex)("City").ToString()
				Dim postalCode As String = customers.Tables(0).Rows(rowIndex)("PostalCode").ToString()
				Dim country As String = customers.Tables(0).Rows(rowIndex)("Country").ToString()
				Dim phone As String = customers.Tables(0).Rows(rowIndex)("Phone").ToString()
				Dim fax As String = customers.Tables(0).Rows(rowIndex)("Fax").ToString()

				' Draw the barcode.
				barcode.Data = customerID
				Dim barcodeImage As Bitmap = barcode.GetImage(e.Graphics.DpiX, e.Graphics.DpiY)
				e.Graphics.DrawImageUnscaled(barcodeImage, CInt(Fix(leftMargin)), CInt(Fix(topMargin + topPosition)))
				barcodeImage.Dispose()

				' Draw the text.
				e.Graphics.DrawString(companyName, fontTitle, blackBrush, leftMargin + leftTextOffset, topMargin + topPosition)
				e.Graphics.DrawString(contactName & " - " & contactTitle, fontText, blackBrush, leftMargin + leftTextOffset, topMargin + topPosition + fontHeight)
				e.Graphics.DrawString(address, fontText, blackBrush, leftMargin + leftTextOffset, topMargin + topPosition + 2*fontHeight)
				e.Graphics.DrawString(city & ", " & postalCode & ", " & country, fontText, blackBrush, leftMargin + leftTextOffset, topMargin + topPosition + 3*fontHeight)
				e.Graphics.DrawString(phone & " / " & fax, fontText, blackBrush, leftMargin + leftTextOffset, topMargin + topPosition + 4*fontHeight)

				' Go to next row.
				rowIndex += 1
				topPosition = topPosition + sectionHeight
			Loop

			' There are more pages if last row has not been reached.
			e.HasMorePages = rowIndex < customers.Tables(0).Rows.Count
		End Sub

		Private Sub printDocument_BeginPrint(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintEventArgs) Handles printDocument.BeginPrint
			' Start printing with first row.
			rowIndex = 0
		End Sub

		Private Sub printDocument_QueryPageSettings(ByVal sender As Object, ByVal e As System.Drawing.Printing.QueryPageSettingsEventArgs) Handles printDocument.QueryPageSettings
			e.PageSettings.Margins.Left = 50
			e.PageSettings.Margins.Top = 50
			e.PageSettings.Margins.Right = 50
			e.PageSettings.Margins.Bottom = 50
		End Sub
	End Class
End Namespace
